from mpi4py import MPI

from matrix_mpi import MatrixMPI as Matrix
from vector_mpi import VectorMPI as Vector

comm = MPI.COMM_WORLD
size = comm.Get_size()
rank = comm.Get_rank()


def cg(n: int, A: Matrix, f: Vector, tol: float):
    # Intialisierung des Startvektors x
    x = Vector([1] * n)

    # Anzahl der Schritte
    count = 0

    # Anfangswerte berechnen
    r = f - A * x  # Anfangsresiduum
    p = r  # Anfangsabstiegsrichtung

    while r.norm() > tol and count < 1000:
        print(f"{count}. Iterationsschritt:\n")
        # print("Iterierte:", x)
        # print("Residuumsnorm: ", r.norm())

        z = A * p  # Matrix-Vektorprodukt berechnen und speichern

        # Minimiere phi in Richung p um neue Iterierte x zu finden
        alpha = (r.T() * p) / (p.T() * z)  # (np.dot(r , p)) / (np.dot(p , z))
        # print(alpha)

        x = x + alpha * p  # neue Itterierte x
        r = r - alpha * z  # neues Residuum

        # Bestimmung der neuen Suchrichtung
        beta = - (r.T() * z) / (p.T() * z)  # (np.dot(r , z)) / (np.dot(p , z))
        p = r + beta * p  # neue konjugierte Abstiegsrichtung

        count = count + 1

    print(f"{rank} APFELSTRUDEL")
    # if rank == 0:
    #     # Vergleich mit numpy-interner Lsg
    #     u = np.linalg.solve(np.array(A.get_data()), np.array(f.get_data()))
    #
    #     print("Lösung mit CG-Verfahren:", x)
    #     print("Numpy interne Lösung:", u)
    #
    #     if (Vector(u) - x).norm() > eps:
    #         print("Der CG-Algorithmus hat nicht richtig funktioniert!")
    #     else:
    #         print("Der CG-Algorithmus war erfolgreich.")
    #
    #     plt.plot(x.get_data(), linewidth=2)
    #     plt.plot(u, linewidth=2)
    #
    #     plt.show()
